#! /usr/bin/perl -w

# Enthral SVN: $Id: install.pl 110 2009-06-02 02:41:35Z frank $
# Source: $HeadURL: http://svn.enthralbbs.com/trunk/install.pl $
# $LastChangedDate: 2009-06-01 22:41:35 -0400 (Mon, 01 Jun 2009) $
# $LastChangedRevision: 110 $
# $LastChangedBy: frank $

# Enthral BBS Auto Install script

# Standard variables and system requests

my $smapiurl = "http://voxel.dl.sourceforge.net/sourceforge/husky/smapi-2.2.4-src.tar.gz";
my $os = $^O;
my $origsysop = "Mercyful Fate";
use File::Copy;
use File::Find;
use Cwd;
my $trunk = getcwd;

# Capture User Input

system("clear");
print "Welcome to the Enthral BBS install script.\n\n";
print "This script will ask you for your Sysop Name and BBS Name and\n";
print "then download and compile the smpai (which is required for Enthral),\n";
print "add the sysop name to the config.ini file, and compile snoop and stats.\n\n";
print "WARNING. I am not responsible for anything that might occur with your\n";
print "system.  While I have done my best to ensure that the script functions as\n";
print "promised, things may go wrong from time to time.  Please ensure you make\n";
print "a complete backup of your system before attempting to use this.\n\n";
print "Are you ready to continue? (y/n): ";

if (<STDIN> =~ /^[yY]/)
{
print "\nSysop Name (Has to match exactly what you plan on using): ";
my $sysop = <>;
chomp ( $sysop );

# Replace Sysop Name in config.ini

chdir "ini/";
my $dir = getcwd;
print "\nReplacing $origsysop with $sysop in config.ini\n\n";
sleep 2;
find(\&wanted,$dir);

print "\nFinished\n";
sleep 2;

sub wanted{
#       (-f $_ && -w $_ && -T $_) or return;
        /\.ini$/ or return;
        my $file=$_;
        my $found = 0; # If the string was found in $file
        print "Searching $file.\n";
        open(INFILE,$file) or (print "Could not open $file for reading: $!\n" and return);
        my @text=<INFILE>;
        close(INFILE);
        for(my $x=0;$x<=$#text;$x++){
                $text[$x]=~s/$origsysop/$sysop/g and $found = 1 and
                        print " -Found in $file (line ".($x+1).")\n";
        }
        if($found){
                open(OUTFILE,">$file") or (print "Unable to open $file for writing: $!\n\t$file must be changed manually\n." and return);
                foreach(@text){
                        print OUTFILE $_;
                }
                close(OUTFILE);
        }
}

sleep 2;


# Download and unpack smapi 2.2
chdir $trunk;
print "\nDownloading smapi-2.2.4-src.tar.gz\n";
sleep 1;
mkdir("smapi_src", 0777) || print $!;
chdir "smapi_src/";
system "wget $smapiurl";

system "tar xzvf smapi-2.2.4-src.tar.gz";
unlink <*.tar.gz*>;
print "\nsmapi-2.2.4-src.tar.gz successfully downloaded and unpacked.\n";

# Configuring smapi

chdir "smapi/";
print "\nChecking OS.";
sleep 1;
print "\nRunning under $os\n";
print "\nCompiling smapi\n";

copy("makefile.lnx","Makefile") or die "Copy failed: $!";
system "make";

print "\nlibsmapilnx.a compiled successfully.  Moving to compile Enthral.\n";
copy("libsmapilnx.a","../../src/libsmapilnx.a") or die "Copy failed: $!";
chdir "../../";

sleep 1;

# run Configure
print "\nRunning configure\n";
sleep 1;
system "./configure";

# run make clean
print "\nRunning make clean\n";
sleep 1;
system "make clean";

# run make
print "\nRunning make\n";
sleep 1;
system "make";

# compile stats
chdir "src/stats";
print "\nCompiling Stats\n";
system "g++ -o stats main.cpp process2.cpp userdat.cpp";
sleep 1;
print "\nStats compile succsessful\n";

# compile snoop
chdir "../snoop";
print "\nCompiling Snoop\n";
system "g++ -o snoop snoop.cpp";
sleep 1;
print "\nSnoop compile succsessful\n";

print "\nCongradulations, Enthral compile complete.\n\n";
}